#!/bin/bash
#
#
# 	Script d'initialisation d'un dépot vMap versionné sous git
#	Initislise l'ensemble des dépendances sous forme de subtrees
#
#	Nécessite xmllint : sudo apt install libxml2-utils
#


APP_NAME="vmap"

# Récupère la liste des dépendances
. ./get_deps.sh

cd ..
if [ -d "$(pwd)/client" ]; then
	rm client
fi
if [ -d "$(pwd)/vas" ]; then
	rm vas
fi
if [ -d "$(pwd)/src" ]; then
	git rm -r src
	git commit -a -m "Reset sources"
fi
mkdir src

if [[ $depsCount > 0 ]]; then

	# Vitis
	echo "---- Init vitis ----"
	git subtree add --squash -m "add subtree" --prefix src/vitis "git@gitlab.veremes.net:Development/vitis_apps/sources/vitis.git" $vitisVersion

	echo "---- Init conf ----"
	git subtree add --squash -m "add subtree" --prefix src/closure "git@gitlab.veremes.net:Development/vitis_apps/sources/closure.git" master

	# Modules
	for (( i=1; i <= $depsCount; i++ )); do
		if [ ${aDeps[$i, nature]} == "modules" ]; then
			echo "---- Init ${aDeps[$i, name]} : ${aDeps[$i, version]}----"

		    # Ajoute le dépôt
			git subtree add --squash -m "add subtree" --prefix src/${aDeps[$i, name]} "git@gitlab.veremes.net:Development/vitis_apps/sources/${aDeps[$i, name]}.git" ${aDeps[$i, version]}
		fi
	done

fi
